@
@ GCat's Master System Emulator
@ Copyright (c) 2012 James Perry
@
@ This program is free software: you can redistribute it and/or modify
@ it under the terms of the GNU General Public License as published by
@ the Free Software Foundation, either version 3 of the License, or
@ (at your option) any later version.
@
@ This program is distributed in the hope that it will be useful,
@ but WITHOUT ANY WARRANTY; without even the implied warranty of
@ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
@ GNU General Public License for more details.
@
@ You should have received a copy of the GNU General Public License
@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
@

@
@ All ED-prefixed instructions implemented in here
@

insned: @ fetch second byte of instruction
	READ_BYTE(r3, r9, r3, r2)
	INC16(r9)

	@ increment R again
	add	r4, r4, #16777216

	@ lookup and jump to instruction
	ldr	r2,[r0, #60]
	ldr	pc,[r2, r3, lsl #2]

	.global	edinsn_table
edinsn_table:
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop

	.word	edinsn40, edinsn41, edinsn42, edinsn43
	.word	edinsn44, edinsn45, edinsn46, edinsn47
	.word	edinsn48, edinsn49, edinsn4a, edinsn4b
	.word	edinsn4c, edinsn4d, edinsn4e, edinsn4f
	.word	edinsn50, edinsn51, edinsn52, edinsn53
	.word	edinsn54, edinsn55, edinsn56, edinsn57
	.word	edinsn58, edinsn59, edinsn5a, edinsn5b
	.word	edinsn5c, edinsn5d, edinsn5e, edinsn5f
	.word	edinsn60, edinsn61, edinsn62, edinsn63
	.word	edinsn64, edinsn65, edinsn66, edinsn67
	.word	edinsn68, edinsn69, edinsn6a, edinsn6b
	.word	edinsn6c, edinsn6d, edinsn6e, edinsn6f
	.word	edinsn70, edinsn71, edinsn72, edinsn73
	.word	edinsn74, edinsn75, edinsn76, edinsn77
	.word	edinsn78, edinsn79, edinsn7a, edinsn7b
	.word	edinsn7c, edinsn7d, edinsn7e, edinsn7f

	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	edinsna0, edinsna1, edinsna2, edinsna3
	.word	ednoop, ednoop, ednoop, ednoop
	.word	edinsna8, edinsna9, edinsnaa, edinsnab
	.word	ednoop, ednoop, ednoop, ednoop
	.word	edinsnb0, edinsnb1, edinsnb2, edinsnb3
	.word	ednoop, ednoop, ednoop, ednoop
	.word	edinsnb8, edinsnb9, edinsnba, edinsnbb
	.word	ednoop, ednoop, ednoop, ednoop

	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop
	.word	ednoop, ednoop, ednoop, ednoop

	@ nop
edinsn7f:
edinsn77:
ednoop:	END_INSN(#8)

	@ in b,(c)
edinsn40:
	mov	r2, r5
	bl	port_in
	and	r5, r5, #0xff
	orr	r5, r5, r2, lsl #8
	bic	r4, r4, #0xfe00		@ clear most flags
	ldr	r3, [r0, #44]
	ldrb	r3, [r3, r2]
	orr	r4, r4, r3, lsl #8	@ set S, Z, 5, 3, P
	END_INSN(#12)

	@ out (c),b
edinsn41:
	mov	r2, r5
	mov	r3, r5, lsr #8
	bl	port_out
	END_INSN(#12)

	@ sbc hl,bc
edinsn42:
	SBC16(r5, r3, r2)
	END_INSN(#15)

	@ ld (NN),bc
edinsn43:
	READ_BYTE(r12, r9, r3, r2)
	INC16(r9)
	READ_BYTE(r3, r9, r3, r2)
	INC16(r9)
	orr	r12, r12, r3, lsl #8
	WRITE_BYTE(r5, r12, r3, r2)
	INC16(r12)
	mov	r5, r5, ror #8
	WRITE_BYTE(r5, r12, r3, r2)
	mov	r5, r5, ror #24
	END_INSN(#20)

	@ neg
	@
	@ Flags for neg:
	@  - S, 5, 3, set from result
	@  - Z set if A=0
	@  - C set if A was 0
	@  - N always set
	@  - Overflow set if A was 0x80
	@  - H set if bit 3 result is set but bit 3 input wasn't
	@
edinsn44:
edinsn4c:
edinsn54:
edinsn5c:
edinsn64:
edinsn6c:
edinsn74:
edinsn7c:
	ands	r2, r4, #0xff		@ get just A
	and	r12, r4, #0x08		@ preserve original bit 3 for H
	and	r4, r4, #0xff000000	@ clear all flags and original A
	orreq	r4, r4, #0x4100		@ set C and Z if A=0
	cmp	r2, #0x80
	orreq	r4, r4, #0x400		@ set V if A=0x80
	rsb	r2, r2, #0x00		@ negate
	and	r2, r2, #0xff
	orr	r4, r4, r2		@ put result in A
	and	r3, r2, #0xa8
	orr	r4, r4, r3, lsl #8	@ set S, 5, 3 flags
	orr	r4, r4, #0x200		@ set N flag
	and	r2, r2, #0x08		@ calculate H flag
	orr	r12, r12, r2, lsr #1
	cmp	r12, #0x04
	orreq	r4, r4, #0x1000
	END_INSN(#8)

	@ retn
edinsn45:
edinsn55:
edinsn5d:
edinsn65:
edinsn6d:
edinsn75:
edinsn7d:
	ldrh	r12,[r0, #20]
	READ_BYTE(r9, r12, r3, r2)
	INC16(r12)
	READ_BYTE(r3, r12, r3, r2)
	INC16(r12)
	strh	r12,[r0, #20]
	orr	r9, r9, r3, lsl #8
	ldrb	r3, [r0, #39]
	strb	r3, [r0, #38]
	END_INSN(#14)
	
	@ im 0
edinsn46:
edinsn66:
	mov	r2, #0
	strb	r2, [r0, #73]
	END_INSN(#8)

	@ ld i,a
edinsn47:
	strb	r4, [r0, #36]
	END_INSN(#9)

	@ in c,(c)
edinsn48:
	mov	r2, r5
	bl	port_in
	and	r5, r5, #0xff
	orr	r5, r5, r2
	bic	r4, r4, #0xfe00		@ clear most flags
	ldr	r3, [r0, #44]
	ldrb	r3, [r3, r2]
	orr	r4, r4, r3, lsl #8	@ set S, Z, 5, 3, P
	END_INSN(#12)

	@ out (c),c
edinsn49:
	mov	r2, r5
	and	r3, r5, #0xff
	bl	port_out
	END_INSN(#12)

	@ adc hl,bc
edinsn4a:
	ADC16(r5, r3, r2)
	END_INSN(#15)

	@ ld bc,(NN)
edinsn4b:
	READ_BYTE(r12, r9, r3, r2)
	INC16(r9)
	READ_BYTE(r3, r9, r3, r2)
	INC16(r9)
	orr	r12, r12, r3, lsl #8
	READ_BYTE(r5, r12, r3, r2)
	INC16(r12)
	READ_BYTE(r3, r12, r3, r2)
	orr	r5, r5, r3, lsl #8
	END_INSN(#20)


	@ reti
edinsn4d:
	ldrh	r12,[r0, #20]
	READ_BYTE(r9, r12, r3, r2)
	INC16(r12)
	READ_BYTE(r3, r12, r3, r2)
	INC16(r12)
	strh	r12,[r0, #20]
	orr	r9, r9, r3, lsl #8
	ldrb	r3, [r0, #39]
	strb	r3, [r0, #38]
	END_INSN(#14)

	@ im 1
edinsn4e:
edinsn56:
edinsn6e:
edinsn76:
	mov	r2, #1
	strb	r2, [r0, #73]
	END_INSN(#8)
	
	@ ld r,a
edinsn4f:
	strb	r4, [r0, #37]
	bic	r4, r4, #0xff000000
	and	r3, r4, #0xff
	orr	r4, r4, r3, lsl #24
	END_INSN(#9)

	@ in d,(c)
edinsn50:
	mov	r2, r5
	bl	port_in
	and	r6, r6, #0xff
	orr	r6, r6, r2, lsl #8
	bic	r4, r4, #0xfe00		@ clear most flags
	ldr	r3, [r0, #44]
	ldrb	r3, [r3, r2]
	orr	r4, r4, r3, lsl #8	@ set S, Z, 5, 3, P
	END_INSN(#12)

	@ out (c),d
edinsn51:
	mov	r2, r5
	mov	r3, r6, lsr #8
	bl	port_out
	END_INSN(#12)

	@ sbc hl,de
edinsn52:
	SBC16(r6, r3, r2)
	END_INSN(#15)

	@ ld (NN),de
edinsn53:
	READ_BYTE(r12, r9, r3, r2)
	INC16(r9)
	READ_BYTE(r3, r9, r3, r2)
	INC16(r9)
	orr	r12, r12, r3, lsl #8
	WRITE_BYTE(r6, r12, r3, r2)
	INC16(r12)
	mov	r6, r6, ror #8
	WRITE_BYTE(r6, r12, r3, r2)
	mov	r6, r6, ror #24
	END_INSN(#20)

	@ ld a,i
edinsn57:
	ldrb	r2, [r0, #36]		@ read I
	bic	r4, r4, #0xff
	orr	r4, r4, r2
	bic	r4, r4, #0xfc00		@ clear most of flags
	ldrb	r3, [r0, #39]		@ read iff2
	cmp	r3, #0
	orrne	r4, r4, #0x400		@ put it in P/V flag
	cmp	r2, #0
	orreq	r4, r4, #0x4000		@ set Z flag
	and	r2, r2, #0xa8
	orr	r4, r4, r2, lsl #8	@ set S, 5, 3 flags
	END_INSN(#9)

	@ in e,(c)
edinsn58:
	mov	r2, r5
	bl	port_in
	and	r6, r6, #0xff00
	orr	r6, r6, r2
	bic	r4, r4, #0xfe00		@ clear most flags
	ldr	r3, [r0, #44]
	ldrb	r3, [r3, r2]
	orr	r4, r4, r3, lsl #8	@ set S, Z, 5, 3, P
	END_INSN(#12)

	@ out (c),e
edinsn59:
	mov	r2, r5
	and	r3, r6, #0xff
	bl	port_out
	END_INSN(#12)

	@ adc hl,de
edinsn5a:
	ADC16(r6, r3, r2)
	END_INSN(#15)

	@ ld de,(NN)
edinsn5b:
	READ_BYTE(r12, r9, r3, r2)
	INC16(r9)
	READ_BYTE(r3, r9, r3, r2)
	INC16(r9)
	orr	r12, r12, r3, lsl #8
	READ_BYTE(r6, r12, r3, r2)
	INC16(r12)
	READ_BYTE(r3, r12, r3, r2)
	orr	r6, r6, r3, lsl #8
	END_INSN(#20)

	@ im 2
edinsn5e:
edinsn7e:
	mov	r2, #2
	strb	r2, [r0, #73]
	END_INSN(#8)
	
	@ ld a,r
edinsn5f:
	ldrb	r2, [r0, #37]		@ read top bit of R
	and	r3, r4, #0x7f000000	@ read low 7 bits of R
	and	r2, r2, #0x80
	orr	r2, r2, r3, lsr #24	@ get complete R value
	bic	r4, r4, #0xff
	orr	r4, r4, r2
	bic	r4, r4, #0xfc00		@ clear most of flags
	ldrb	r3, [r0, #39]		@ read iff2
	cmp	r3, #0
	orrne	r4, r4, #0x400		@ put it in P/V flag
	cmp	r2, #0
	orreq	r4, r4, #0x4000		@ set Z flag
	and	r2, r2, #0xa8
	orr	r4, r4, r2, lsl #8	@ set S, 5, 3 flags
	END_INSN(#9)

	@ in h,(c)
edinsn60:
	mov	r2, r5
	bl	port_in
	and	r7, r7, #0xff
	orr	r7, r7, r2, lsl #8
	bic	r4, r4, #0xfe00		@ clear most flags
	ldr	r3, [r0, #44]
	ldrb	r3, [r3, r2]
	orr	r4, r4, r3, lsl #8	@ set S, Z, 5, 3, P
	END_INSN(#12)

	@ out (c),h
edinsn61:
	mov	r2, r5
	mov	r3, r7, lsr #8
	bl	port_out
	END_INSN(#12)

	@ sbc hl,hl
edinsn62:
	SBC16(r7, r3, r2)
	END_INSN(#15)

	@ ld (NN),hl
edinsn63:
	READ_BYTE(r12, r9, r3, r2)
	INC16(r9)
	READ_BYTE(r3, r9, r3, r2)
	INC16(r9)
	orr	r12, r12, r3, lsl #8
	WRITE_BYTE(r7, r12, r3, r2)
	INC16(r12)
	mov	r7, r7, ror #8
	WRITE_BYTE(r7, r12, r3, r2)
	mov	r7, r7, ror #24
	END_INSN(#20)

	@ rrd
edinsn67:
	READ_BYTE(r12, r7, r3, r2)		@ read from (HL)
	and	r2, r12, #0xf			@ new low bits for accum
	mov	r12, r12, lsr #4
	orr	r12, r12, r4, lsl #4
	and	r12, r12, #0xff			@ new value for (HL)
	bic	r4, r4, #0xf
	orr	r4, r4, r2			@ write back to accum
	WRITE_BYTE(r12, r7, r3, r2)		@ write back to (HL)
	bic	r4, r4, #0xfe00			@ clear most flags
	ldr	r3, [r0, #44]
	ldrb	r3, [r3, r12]
	orr	r4, r4, r3, lsl #8		@ set S, Z, 5, 3, P
	END_INSN(#18)

	@ in l,(c)
edinsn68:
	mov	r2, r5
	bl	port_in
	and	r7, r7, #0xff00
	orr	r7, r7, r2
	bic	r4, r4, #0xfe00		@ clear most flags
	ldr	r3, [r0, #44]
	ldrb	r3, [r3, r2]
	orr	r4, r4, r3, lsl #8	@ set S, Z, 5, 3, P
	END_INSN(#12)

	@ out (c),l
edinsn69:
	mov	r2, r5
	and	r3, r7, #0xff
	bl	port_out
	END_INSN(#12)

	@ adc hl,hl
edinsn6a:
	ADC16(r7, r3, r2)
	END_INSN(#15)

	@ ld hl,(NN)
edinsn6b:
	READ_BYTE(r12, r9, r3, r2)
	INC16(r9)
	READ_BYTE(r3, r9, r3, r2)
	INC16(r9)
	orr	r12, r12, r3, lsl #8
	READ_BYTE(r7, r12, r3, r2)
	INC16(r12)
	READ_BYTE(r3, r12, r3, r2)
	orr	r7, r7, r3, lsl #8
	END_INSN(#20)

	@ rld
edinsn6f:
	READ_BYTE(r12, r7, r3, r2)		@ read (HL)
	mov	r2, r12, lsr #4			@ new low bits for accum
	and	r3, r4, #0xf
	mov	r12, r12, lsl #4
	orr	r12, r12, r3
	and	r12, r12, #0xff			@ new data for (HL)
	bic	r4, r4, #0xf
	orr	r4, r4, r2			@ write back to accum
	WRITE_BYTE(r12, r7, r3, r2)		@ write back to (HL)
	bic	r4, r4, #0xfe00			@ clear most flags
	ldr	r3, [r0, #44]
	ldrb	r3, [r3, r12]
	orr	r4, r4, r3, lsl #8		@ set S, Z, 5, 3, P
	END_INSN(#18)

	
	@ in (c)
edinsn70:
	mov	r2, r5
	bl	port_in
	bic	r4, r4, #0xfe00		@ clear most flags
	ldr	r3, [r0, #44]
	ldrb	r3, [r3, r2]
	orr	r4, r4, r3, lsl #8	@ set S, Z, 5, 3, P
	END_INSN(#12)

	@ out(c),0
edinsn71:
	mov	r2, r5
	mov	r3, #0
	bl	port_out
	END_INSN(#12)

	@ sbc hl,sp
edinsn72:
	ldrh	r12, [r0, #20]
	SBC16(r12, r3, r2)
	END_INSN(#15)

	@ ld (NN),sp
edinsn73:
	ldrh	r8, [r0, #20]
	READ_BYTE(r12, r9, r3, r2)
	INC16(r9)
	READ_BYTE(r3, r9, r3, r2)
	INC16(r9)
	orr	r12, r12, r3, lsl #8
	WRITE_BYTE(r8, r12, r3, r2)
	INC16(r12)
	mov	r8, r8, ror #8
	WRITE_BYTE(r8, r12, r3, r2)
	END_INSN(#20)

	@ in a,(c)
edinsn78:
	mov	r2, r5
	bl	port_in
	bic	r4, r4, #0xff
	orr	r4, r4, r2
	bic	r4, r4, #0xfe00		@ clear most flags
	ldr	r3, [r0, #44]
	ldrb	r3, [r3, r2]
	orr	r4, r4, r3, lsl #8	@ set S, Z, 5, 3, P
	END_INSN(#12)

	@ out (c),a
edinsn79:
	mov	r2, r5
	and	r3, r4, #0xff
	bl	port_out
	END_INSN(#12)

	@ adc hl,sp
edinsn7a:
	ldrh	r12, [r0, #20]
	ADC16(r12, r3, r2)
	END_INSN(#15)

	@ ld sp,(NN)
edinsn7b:
	READ_BYTE(r12, r9, r3, r2)
	INC16(r9)
	READ_BYTE(r3, r9, r3, r2)
	INC16(r9)
	orr	r12, r12, r3, lsl #8
	READ_BYTE(r3, r12, r3, r2)
	INC16(r12)
	strb	r3, [r0, #20]
	READ_BYTE(r3, r12, r3, r2)
	strb	r3, [r0, #21]
	END_INSN(#20)


	@ ldi
edinsna0:
	READ_BYTE(r12, r7, r3, r2)
	WRITE_BYTE(r12, r6, r3, r2)
	INC16(r7)
	INC16(r6)
	DEC16(r5)
	bic	r4, r4, #0x3e00		@ clear some flags
	and	r3, r4, #0xff
	add	r3, r3, r12		@ copied value + A
	and	r2, r3, #0x02		@ get bit 1
	and	r3, r3, #0x08		@ get bit 3
	orr	r4, r4, r3, lsl #8	@ set flag 3
	orr	r4, r4, r2, lsl #12	@ set flag 5
	cmp	r5, #0
	orrne	r4, r4, #0x400		@ set P if BC is non-zero
	END_INSN(#16)

	@ cpi
	@ FIXME: undoc flags and H not correct
edinsna1:
	READ_BYTE(r12, r7, r3, r2)
	INC16(r7)
	DEC16(r5)
	bic	r4, r4, #0xfe00		@ clear most flags
	and	r2, r4, #0xff
	subs	r2, r2, r12		@ subtraction for compare
	orreq	r4, r4, #0x4000		@ set Z flag if equal
	orr	r4, r4, #0x200		@ set N flag always
	cmp	r5, #0
	orrne	r4, r4, #0x400		@ set P if BC is nz
	and	r2, r2, #0xa8
	orr	r4, r4, r2, lsl #8
	END_INSN(#16)

	@ ini
	@ FIXME: flags all wrong except Z & N
edinsna2:
	mov	r2, r5
	bl	port_in
	mov	r12, r2
	WRITE_BYTE(r12, r7, r3, r2)
	INC16(r7)
	sub	r5, r5, #0x100		@ dec b
	bic	r5, r5, #0xff000000
	bic	r5, r5, #0xff0000
	bic	r4, r4, #0x4000
	tst	r5, #0xff00
	orreq	r4, r4, #0x4000		@ set Z flag if B set
	orr	r4, r4, #0x0200		@ N flag always set
	END_INSN(#16)
	
	
	@ outi
	@ FIXME: flags mostly wrong
edinsna3:
	mov	r3, #0x95
	orr	r3, #0x1c00
	cmp	r3, r9
	addeq	r9, r9, #0x3e
	beq	next_instruction
	
	READ_BYTE(r3, r7, r3, r2)
	mov	r2, r5
	bl	port_out
	sub	r5, r5, #0x100		@ dec b
	bic	r5, r5, #0xff000000
	bic	r5, r5, #0xff0000
	INC16(r7)
	bic	r4, r4, #0x4000
	tst	r5, #0xff00
	orreq	r4, r4, #0x4000		@ set Z flag if B set
	orr	r4, r4, #0x0200		@ N flag always set
	END_INSN(#16)
	

	@ ldd
edinsna8:
	READ_BYTE(r12, r7, r3, r2)
	WRITE_BYTE(r12, r6, r3, r2)
	DEC16(r7)
	DEC16(r6)
	DEC16(r5)
	bic	r4, r4, #0x3e00		@ clear some flags
	and	r3, r4, #0xff
	add	r3, r3, r12		@ copied value + A
	and	r2, r3, #0x02		@ get bit 1
	and	r3, r3, #0x08		@ get bit 3
	orr	r4, r4, r3, lsl #8	@ set flag 3
	orr	r4, r4, r2, lsl #12	@ set flag 5
	cmp	r5, #0
	orrne	r4, r4, #0x400		@ set P if BC is non-zero
	END_INSN(#16)

	
	@ cpd
	@ FIXME: undoc flags and H not correct
edinsna9:
	READ_BYTE(r12, r7, r3, r2)
	DEC16(r7)
	DEC16(r5)
	bic	r4, r4, #0xfe00		@ clear most flags
	and	r2, r4, #0xff
	subs	r2, r2, r12		@ subtraction for compare
	orreq	r4, r4, #0x4000		@ set Z flag if equal
	orr	r4, r4, #0x200		@ set N flag always
	cmp	r5, #0
	orrne	r4, r4, #0x400		@ set P if BC is nz
	and	r2, r2, #0xa8
	orr	r4, r4, r2, lsl #8
	END_INSN(#16)

	@ ind
	@ FIXME: flags wrong except N & Z
edinsnaa:
	mov	r2, r5
	bl	port_in
	mov	r12, r2
	WRITE_BYTE(r12, r7, r3, r2)
	DEC16(r7)
	sub	r5, r5, #0x100		@ dec b
	bic	r5, r5, #0xff000000
	bic	r5, r5, #0xff0000
	bic	r4, r4, #0x4000
	tst	r5, #0xff00
	orreq	r4, r4, #0x4000		@ set Z flag if B set
	orr	r4, r4, #0x0200		@ N flag always set
	END_INSN(#16)

	@ outd
	@ FIXME: flags mostly wrong
edinsnab:
	READ_BYTE(r3, r7, r3, r2)
	mov	r2, r5
	bl	port_out
	sub	r5, r5, #0x100		@ dec b
	bic	r5, r5, #0xff000000
	bic	r5, r5, #0xff0000
	DEC16(r7)
	bic	r4, r4, #0x4000
	tst	r5, #0xff00
	orreq	r4, r4, #0x4000		@ set Z flag if B set
	orr	r4, r4, #0x0200		@ N flag always set
	END_INSN(#16)

	@ ldir
edinsnb0:
	READ_BYTE(r12, r7, r3, r2)
	WRITE_BYTE(r12, r6, r3, r2)
	INC16(r7)
	INC16(r6)
	DEC16(r5)
	cmp	r5, #0
	beq	ldirdone
	DEC16(r9)			@ repeat instruction
	DEC16(r9)
	END_INSN(#21)
ldirdone:	
	bic	r4, r4, #0x3e00		@ clear some flags
	and	r3, r4, #0xff
	add	r3, r3, r12		@ copied value + A
	and	r2, r3, #0x02		@ get bit 1
	and	r3, r3, #0x08		@ get bit 3
	orr	r4, r4, r3, lsl #8	@ set flag 3
	orr	r4, r4, r2, lsl #12	@ set flag 5
	END_INSN(#16)

	
	@ cpir
	@ FIXME: undoc flags and H not correct
edinsnb1:
	READ_BYTE(r12, r7, r3, r2)
	INC16(r7)
	DEC16(r5)
	bic	r4, r4, #0xfe00		@ clear most flags
	and	r2, r4, #0xff
	subs	r2, r2, r12		@ subtraction for compare
	orreq	r4, r4, #0x4000		@ set Z flag if equal
	beq	cpirdone
	cmp	r5, #0
	beq	cpirdone
	DEC16(r9)
	DEC16(r9)
	END_INSN(#21)			@ repeat
cpirdone:
	cmp	r5, #0
	orrne	r4, r4, #0x400		@ set P if BC is nz
	orr	r4, r4, #0x200		@ set N flag always
	and	r2, r2, #0xa8
	orr	r4, r4, r2, lsl #8
	END_INSN(#16)

	
	@ inir
	@ FIXME: most flags wrong
edinsnb2:
	mov	r2, r5
	bl	port_in
	mov	r12, r2
	WRITE_BYTE(r12, r7, r3, r2)
	INC16(r7)
	sub	r5, r5, #0x100		@ dec b
	bic	r5, r5, #0xff000000
	bic	r5, r5, #0xff0000
	tst	r5, #0xff00
	beq	inir_done
	DEC16(r9)
	DEC16(r9)
	END_INSN(#21)
inir_done:
	orr	r4, r4, #0x4200		@ N and Z flags always set
	END_INSN(#16)

	
	@ otir
	@ FIXME: flags mostly wrong
edinsnb3:
	READ_BYTE(r3, r7, r3, r2)
	mov	r2, r5
	bl	port_out
	sub	r5, r5, #0x100		@ dec b
	bic	r5, r5, #0xff000000
	bic	r5, r5, #0xff0000
	INC16(r7)
	tst	r5, #0xff00
	beq	otirdone
	DEC16(r9)
	DEC16(r9)			@ repeat
	END_INSN(#21)
otirdone:	
	orr	r4, r4, #0x4200		@ N and Z flags always set
	END_INSN(#16)

	@ lddr
edinsnb8:
	READ_BYTE(r12, r7, r3, r2)
	WRITE_BYTE(r12, r6, r3, r2)
	DEC16(r7)
	DEC16(r6)
	DEC16(r5)
	cmp	r5, #0
	beq	lddrdone
	DEC16(r9)			@ repeat instruction
	DEC16(r9)
	END_INSN(#21)
lddrdone:	
	bic	r4, r4, #0x3e00		@ clear some flags
	and	r3, r4, #0xff
	add	r3, r3, r12		@ copied value + A
	and	r2, r3, #0x02		@ get bit 1
	and	r3, r3, #0x08		@ get bit 3
	orr	r4, r4, r3, lsl #8	@ set flag 3
	orr	r4, r4, r2, lsl #12	@ set flag 5
	END_INSN(#16)

	@ cpdr
	@ FIXME: undoc flags and H not correct
edinsnb9:
	READ_BYTE(r12, r7, r3, r2)
	DEC16(r7)
	DEC16(r5)
	bic	r4, r4, #0xfe00		@ clear most flags
	and	r2, r4, #0xff
	subs	r2, r2, r12		@ subtraction for compare
	orreq	r4, r4, #0x4000		@ set Z flag if equal
	beq	cpdrdone
	cmp	r5, #0
	beq	cpdrdone
	DEC16(r9)
	DEC16(r9)
	END_INSN(#21)			@ repeat
cpdrdone:
	cmp	r5, #0
	orrne	r4, r4, #0x400		@ set P if BC is nz
	orr	r4, r4, #0x200		@ set N flag always
	and	r2, r2, #0xa8
	orr	r4, r4, r2, lsl #8
	END_INSN(#16)

	@ indr
	@ FIXME: most flags wrong
edinsnba:
	mov	r2, r5
	bl	port_in
	mov	r12, r2
	WRITE_BYTE(r12, r7, r3, r2)
	DEC16(r7)
	sub	r5, r5, #0x100		@ dec b
	bic	r5, r5, #0xff000000
	bic	r5, r5, #0xff0000
	tst	r5, #0xff00
	beq	indr_done
	DEC16(r9)
	DEC16(r9)
	END_INSN(#21)
indr_done:
	orr	r4, r4, #0x4200		@ N and Z flags always set
	END_INSN(#16)

	
	@ otdr
	@ FIXME: flags mostly wrong
edinsnbb:
	READ_BYTE(r3, r7, r3, r2)
	mov	r2, r5
	bl	port_out
	sub	r5, r5, #0x100		@ dec b
	bic	r5, r5, #0xff000000
	bic	r5, r5, #0xff0000
	DEC16(r7)
	tst	r5, #0xff00
	beq	otdrdone
	DEC16(r9)
	DEC16(r9)			@ repeat
	END_INSN(#21)
otdrdone:	
	orr	r4, r4, #0x4200		@ N and Z flags always set
	END_INSN(#16)

